SystemOrganization addCategory: #GroupManager!

Object subclass: #AbstractGroup
	instanceVariableNames: 'name readOnly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!AbstractGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 14:06'!
named: aString

	^ self new name: aString! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:00'!
beReadOnly

	readOnly := true! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:22'!
elements

	^ self subclassResponsibility! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:04'!
ifAllowed: aBlock

	^ self isReadOnly
		ifFalse: aBlock! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:01'!
initialize

	super initialize.
	readOnly := false! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:00'!
isReadOnly

	^ readOnly == true! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:03'!
name

	^ name! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:04'!
name: aString

	self ifAllowed: [ name := aString ]! !

AbstractGroup subclass: #DynamicGroup
	instanceVariableNames: 'model selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!DynamicGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 15:38'!
named: aString model: aClass selector: aSelector

	^ self basicNew
			name: aString;
			model: aClass;
			selector: aSelector;
			initialize;
			yourself! !

!DynamicGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:23'!
elements

	^ (self model perform: self selector) copy! !

!DynamicGroup methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/18/2011 15:15'!
initialize

	super initialize.
	readOnly := true! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:23'!
model

	^ model! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:39'!
model: anObject

	self ifAllowed: [	model := anObject ]! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:23'!
selector

	^ selector! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:39'!
selector: anObject

	self ifAllowed: [	selector := anObject ]! !

AbstractGroup subclass: #StaticGroup
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!StaticGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 14:29'!
named: aString with: aCollection

	^ (super named: aString) with: aCollection! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:05'!
add: anElement

	^ self ifAllowed: [ elements add: anElement ]! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:22'!
elements

	^ elements copy! !

!StaticGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:01'!
initialize

	super initialize.
	readOnly := false! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:05'!
remove: anElement

	^ self ifAllowed: [ elements remove: anElement ]! !

!StaticGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:30'!
with: aCollection

	self ifAllowed: [ elements := aCollection ]! !

Object subclass: #GroupsManager
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupsManager methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/18/2011 15:18'!
addADynamicGroup

	| entry aClass aSelector |
	entry := UIManager default textEntry: 'Name of the new group:' title: 'Create a new group' entryText: 'MyNewGroupName'.
	aClass := nil.
	aSelector := nil.
	^ entry ifNotNil: [ self addADynamicGroupSilentlyNamed: entry model: aClass selector: aSelector ].! !

!GroupsManager methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 3/18/2011 15:17'!
addADynamicGroupSilentlyNamed: entry model: aClass selector: aSelector

	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ 
			^ self groups add: (DynamicGroup named: entry model: aClass selector: aSelector)]! !

!GroupsManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/18/2011 14:26'!
addAGroup

self halt! !

!GroupsManager methodsFor: 'static group' stamp: 'BenjaminVanRyseghem 3/18/2011 14:37'!
addAStaticGroupSilentlyNamed: entry with: aCollection

	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ 
			^ self groups add: (StaticGroup named: entry with: aCollection)]! !

!GroupsManager methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/18/2011 15:03'!
addAnEmptyStaticGroup

	| entry |
	entry := UIManager default textEntry: 'Name of the new group:' title: 'Create a new group' entryText: 'MyNewGroupName'.
	^ entry ifNotNil: [ self addAnEmptyStaticGroupSilentlyNamed: entry ].! !

!GroupsManager methodsFor: 'static group' stamp: 'BenjaminVanRyseghem 3/18/2011 14:26'!
addAnEmptyStaticGroupSilentlyNamed: entry

	^ self addAStaticGroupSilentlyNamed: entry with: OrderedCollection new! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:40'!
groupNamed: aString

	^ self groups detect: [:each | each name = aString]! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:04'!
groups

	^  groups ifNil: [ groups := OrderedCollection new ]! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:32'!
groupsNames

	^ self groups collect: [:group | group name ]! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:37'!
includesAGroupNamed: aName

	^ self groupsNames includes: aName! !

!GroupsManager methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/16/2011 17:52'!
openError

	StandardWindow new alert: 'This group already exists' title: 'Already exists'! !

!GroupsManager methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/18/2011 15:09'!
openRemoveDialogOn: aGroup

	^ StandardWindow new questionWithoutCancel: ('Dou you really want to delete the group named ', aGroup name) title: 'Are you sure ?'! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:51'!
remove: aClass from: aGroup

	aGroup
		ifAllowed: [^ aGroup remove: aClass].
	^ nil! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:10'!
removeAGroup: aGroup

	| yesIWantToRemoveTheGroup |
	yesIWantToRemoveTheGroup := self openRemoveDialogOn: aGroup.
	(yesIWantToRemoveTheGroup not or: [ aGroup isReadOnly ])
		ifTrue: [ ^ self ].
	^ groups remove: aGroup.
! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:07'!
renameAGroup: aGroup

	| entry |
	entry := UIManager default request: 'Name of the new group' initialAnswer: '' title: 'Create a new group'.
	(entry isNil or: [entry isEmpty]) ifTrue: [^ aGroup].
	((self includesAGroupNamed: entry) or: [ aGroup isReadOnly ])
		ifTrue: [ ^ self openError ].
	aGroup name: entry.
	^ aGroup	
! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:54'!
sort: aBlock

	^ groups := self groups sort: aBlock! !
